-- Author      : CaptJack2883
-- Create Date : 10/08/2012 
-- Modify Date : 10/14/2020 
-- Version     : 1.12

local JFEmptySlots = 0
local JFEmptySlots0 = 0
local JFEmptySlots1 = 0
local JFEmptySlots2 = 0
local JFEmptySlots3 = 0
local JFEmptySlots4 = 0
local newIndex = 1
local tableGrey = {}
local tableGSorted = {}
local newSortIndex = 1
JFHowMany = nil
JFMaxCopperDelete = nil
JFVerboseToggle = nil
JFEnglishVerbose = "Off"
JFWaitTotal = 0
JFWaitFrame = nil
JFEventFrame = nil
JFMainHidden = nil

JFEventFrame = CreateFrame("FRAME", nil, UIParent)
if JFEventFrame ~= nil then
	print("JFEventFrame has been created")
end
JFWaitFrame = CreateFrame("FRAME", nil, UIParent)
if JFWaitFrame ~= nil then
	print("JFWaitFrame is not NIL")
end

JFEventFrame:RegisterEvent("LOOT_CLOSED")
JFEventFrame:RegisterEvent("ADDON_LOADED")
JFEventFrame:RegisterEvent("PLAYER_LOGOUT") --	Probably don't need/use this.
JFEventFrame:RegisterForDrag("LeftButton")

function JFEventHandler(self, event, ...)
	local arg1 = ...
	if event == "ADDON_LOADED" and arg1 == "Junk_Filter" then		
		if JFHowMany == nil then
			JFHowMany = 5
		else
		end
		if JFMaxCopperDelete == nil then
			JFMaxCopperDelete = 10000
		else
		end
		if JFVerboseToggle == nil then
			JFVerboseToggle = false
		else
		end	
		if JFMainHidden == nil then
			JFMainHidden = 1
		else
		end
		if JFMainHidden == 0 then
			JunkFrame:Hide()
		elseif JFMainHidden == 1 then
			JunkFrame:Show()
		end
			JFGetEmptySlots()
		print("Junk Filter has been loaded.")
	elseif event == "PLAYER_LOGOUT" then
		-- What to do on logout.
	elseif event == "LOOT_CLOSED" then
		JFGetEmptySlots()
		if JFEmptySlots < JFHowMany then
			for i = 1,JFHowMany do
				JFGetEmptySlots()
				if JFEmptySlots < JFHowMany then
					JFLootClosed()
				end
			end
		end
	end
end

function JFonUpdate(self,elapsed)
    JFWaitTotal = JFWaitTotal + elapsed
    if JFWaitTotal >= 1 then
		-- This is where you put stuff that happens every Tick.
        
		--print("ping!")
				
		
		--After you do your stuff, reset the wait time.
        JFWaitTotal = 0 
	end
end

--SetScripts MUST be AFTER the function they call.
JFEventFrame:SetScript("OnEvent", JFEventHandler)
JFWaitFrame:SetScript("OnUpdate", JFonUpdate)

function JFBtnCheck_OnClick() --Happens when Button is clicked.
	JFGetEmptySlots()
	if JFVerboseToggle == 1 then
		print("Junk Filter has found", JFEmptySlots, "Empty Slots.")
	end
end

function JFGetEmptySlots() --Tells me how many empty slots there are.
	--Need to add wait here...
	JFEmptySlots0 = GetContainerNumFreeSlots(0)
	JFEmptySlots1 = GetContainerNumFreeSlots(1)
	JFEmptySlots2 = GetContainerNumFreeSlots(2)
	JFEmptySlots3 = GetContainerNumFreeSlots(3)
	JFEmptySlots4 = GetContainerNumFreeSlots(4)
	JFEmptySlots = JFEmptySlots0 + JFEmptySlots1 + JFEmptySlots2 + JFEmptySlots3 + JFEmptySlots4
	--if JFVerboseToggle == 1 then
	--	print("Junk Filter has found", JFEmptySlots, "Empty Slots.")
	--end
end

function JFLootClosed() --Called when Loot Window is closed.
	if JFVerboseToggle == 1 then
		print("The Loot Window has been Closed.")
	end
	JFGetEmptySlots()
	if JFHowMany ~= nil then
		if JFEmptySlots < JFHowMany then --check to see if you have enough slots empty.
			JFDeleteGreys()
		end
		if JFEmptySlots > JFHowMany then
   			if JFVerboseToggle == 1 then
				print("You still have plenty of bag space.")
			end
		end
	end
end


function JFDeleteGreys()
	JFGetEmptySlots()
	if JFEmptySlots < JFHowMany then
		--This will delete the lowest vendoring Grey Item
		if JFMaxCopperDelete ~= nil then
			if JFVerboseToggle == 1 then
				print("You have less than", JFHowMany, "slots empty.")
				print("An item will be deleted.")
			end
			tableGrey = {}
			tableGSorted = {}
			newIndex = 1
			newSortIndex = 1
			JFFindGreyItems()
			--This works.
			for i = 1,JFMaxCopperDelete do
				if tableGrey[i] ~= nil then
					tableGSorted[newSortIndex] = tableGrey[i]
					newSortIndex = newSortIndex + 1
				else	
				end
			end
			for i = 1,newSortIndex do			
				JFGetEmptySlots()
				if JFEmptySlots < JFHowMany then
					if tableGSorted[i] ~= nil then
						JFDeleteItem(tableGSorted[i])
						tableGrey = {}
						tableGSorted = {}
						--break						
					else
					end
				else
				end
			end
		end
	end
end

function JFFindGreyItems()
	--Finds lowest cost grey item.
	for bag = 0,4 do
		for slot = 1,GetContainerNumSlots(bag) do
			texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bag, slot)
			if quality ~= nil then
				iName, iLink, iRarity, iLevel, iMinLevel, iType, iSubType, iStackCount, iEquipLoc, iTexture, iSellPrice = GetItemInfo(itemLink)
			else
				if JFVerboseToggle == 1 then
					print("I have found an empty slot.")
				end
			end	
			if iRarity == 0 then
				if JFVerboseToggle == 1 then
					print("I have found", itemCount, iLink, "it is Grey, and will be deleted.")
				end
				JFPutIntoGreyTable()
			else
			end						
			if iRarity == -1 then
				if JFVerboseToggle == 1 then
					print("I have found", itemCount, iLink, "but I don't know this item.")
				end
			else
				if iRarity == nil then
				else
					if itemCount == nil then
					else
						if JFVerboseToggle == 1 then
							print("This", itemCount, iLink, "is not grey.")
						end
					end
				end
			end					
		end			
	end			
end

function JFBtnTest_OnClick()
	print("You have selected:", JFHowMany, "empty slots.")
	print("You have selected:", JFMaxCopperDelete, "max copper delete.")
	JFFindGreyItems()
end

function JFBtnDelete_OnClick()
	JFGetEmptySlots()
	if JFHowMany ~= nil then
		if JFEmptySlots < JFHowMany then
			JFDeleteGreys()
		end
	end
end

--	Creates a table of items to be deleted.
function JFPutIntoGreyTable()
	tableGrey[iSellPrice*itemCount+newIndex] = iLink
	newIndex = newIndex + 1
	iRarity = nil
	quality = nil
end

--	Deletes the item whose link is given.
function JFDeleteItem(iLinkDelete)
	for bag = 0,4 do
		for slot = 1,GetContainerNumSlots(bag) do
			JFGetEmptySlots()
			if JFHowMany ~= nil then
				if JFEmptySlots < JFHowMany then
					texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bag, slot)
					if quality ~= nil then
						if iLinkDelete == itemLink then
							PickupContainerItem(bag, slot)
							DeleteCursorItem()
							if JFVerboseToggle == 1 then	
								print("I have deleted", itemLink)
							end
							tableGrey = {}
							tableGSorted = {}
						else
						end
					else
					end
				else
				end
			end
		end				
	end
end

function JFBtnHide_OnClick()
	JunkFrame:Hide()
	JFMainHidden = 0
end

function JFButtonOptions_OnClick()
	JFConfigShow()
end
 
 